Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 5105)
@@ -1916,25 +2262,160 @@
                ii = ( ji - mis_crs(2) ) * rfactx_r + 2  
                ij = ( jj - njstr ) * rfacty_r + 3
-               IF( jk==1 .AND. ii==2 .AND. ij==18 )THEN
-               WRITE(narea+200,*)"crs_dom_sfc ",zsurf(ji,jj  ,jk) , zsurf(ji+1,jj  ,jk) , zsurf(ji+2,jj  ,jk)  &
-                    &                    , zsurf(ji,jj+1,jk) , zsurf(ji+1,jj+1,jk) , zsurf(ji+2,jj+1,jk)  &
-                    &                    , zsurf(ji,jj+2,jk) , zsurf(ji+1,jj+2,jk) , zsurf(ji+2,jj+2,jk) 
-               call flush(narea+200)
-               ENDIF
                !
                p_surf_crs    (ii,ij,jk) =  zsurf(ji,jj  ,jk) + zsurf(ji+1,jj  ,jk) + zsurf(ji+2,jj  ,jk)  &
                     &                    + zsurf(ji,jj+1,jk) + zsurf(ji+1,jj+1,jk) + zsurf(ji+2,jj+1,jk)  &
                     &                    + zsurf(ji,jj+2,jk) + zsurf(ji+1,jj+2,jk) + zsurf(ji+2,jj+2,jk)  
-               IF( jk==1 .AND. ii==2 .AND. ij==18 )WRITE(narea+200,*)"crs_dom_sfc ",p_surf_crs    (ii,ij,jk) ; call flush(narea+200)
                p_surf_crs_msk(ii,ij,jk) =  zsurfmsk(ji,jj  ,jk) + zsurfmsk(ji+1,jj  ,jk) + zsurfmsk(ji+2,jj  ,jk)  &
                     &                    + zsurfmsk(ji,jj+1,jk) + zsurfmsk(ji+1,jj+1,jk) + zsurfmsk(ji+2,jj+1,jk)  &
                     &                    + zsurfmsk(ji,jj+2,jk) + zsurfmsk(ji+1,jj+2,jk) + zsurfmsk(ji+2,jj+2,jk)  
+
+               !cbr
+               iji=117 ; ijj=211
+               iji=iji-nimpp_crs+1 ; ijj=ijj-njmpp_crs+1
+               IF( ii==iji .AND. ij==ijj .AND. jk==74 )THEN
+               WRITE(narea+5000,*)"SFC W =======> "
+               WRITE(narea+5000,*)ii,ij,jk
+               WRITE(narea+5000,*)ji,jj
+               WRITE(narea+5000,*)zsurfmsk(ji,jj  ,jk) , zsurfmsk(ji+1,jj  ,jk) , zsurfmsk(ji+2,jj  ,jk)
+               WRITE(narea+5000,*)zsurfmsk(ji,jj+1,jk) , zsurfmsk(ji+1,jj+1,jk) , zsurfmsk(ji+2,jj+1,jk)
+               WRITE(narea+5000,*)zsurfmsk(ji,jj+2,jk) , zsurfmsk(ji+1,jj+2,jk) , zsurfmsk(ji+2,jj+2,jk)
+               WRITE(narea+5000,*) p_surf_crs    (ii,ij,jk), p_surf_crs_msk(ii,ij,jk) 
+               ENDIF
+
+
             ENDDO      
          ENDDO
       ENDDO   
-      WRITE(narea+200,*)"crs_dom_sfc end ", p_surf_crs    (2,18,1)
+
+      CASE ('U')
+
+     IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+         IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+            je_2 = mje_crs(2)
+            DO jk = 1, jpk
+               DO ji = nistr, niend, nn_factx
+                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
+                  !    
+                  p_surf_crs    (ii,2,jk) =  zsurf(ji+2,je_2  ,jk)
+                  !
+                  p_surf_crs_msk(ii,2,jk) =  zsurfmsk(ji+2,je_2,jk)
+                  !
+               ENDDO
+            ENDDO
+         ENDIF
+      ELSE
+         je_2 = mjs_crs(2)
+         DO jk = 1, jpk
+            DO ji = nistr, niend, nn_factx
+               ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
+               !  
+               p_surf_crs    (ii,2,jk) =  zsurf(ji+2,je_2  ,jk)  &
+                    &                   + zsurf(ji+2,je_2+1,jk)  &
+                    &                   + zsurf(ji+2,je_2+2,jk)
+
+               p_surf_crs_msk(ii,2,jk) =  zsurfmsk(ji+2,je_2  ,jk)  &
+                    &                   + zsurfmsk(ji+2,je_2+1,jk)  &
+                    &                   + zsurfmsk(ji+2,je_2+2,jk)
+                ENDDO
+            ENDDO
+      ENDIF
+
+      DO jk = 1, jpk
+         DO jj = njstr, njend, nn_facty
+            DO ji = nistr, niend, nn_factx
+               ii = ( ji - mis_crs(2) ) * rfactx_r + 2
+               ij = ( jj - njstr ) * rfacty_r + 3
+               !
+               p_surf_crs    (ii,ij,jk) =  zsurf(ji+2,jj  ,jk)  &
+                    &                    + zsurf(ji+2,jj+1,jk)  &
+                    &                    + zsurf(ji+2,jj+2,jk)
+               p_surf_crs_msk(ii,ij,jk) =  zsurfmsk(ji+2,jj  ,jk)  &
+                    &                    + zsurfmsk(ji+2,jj+1,jk)  &
+                    &                    + zsurfmsk(ji+2,jj+2,jk)
+               !cbr
+               !iji=117 ; ijj=211
+               !iji=iji-nimpp_crs+1 ; ijj=ijj-njmpp_crs+1
+               !IF( ii==iji .AND. ij==ijj .AND. jk==74 )THEN
+               !WRITE(narea+5000,*)"SFC U =======> "
+               !WRITE(narea+5000,*)ii,ij,jk
+               !WRITE(narea+5000,*)ji,jj
+               !WRITE(narea+5000,*)mis_crs(2),rfactx_r , ( ji - 1 - mis_crs(2) ) * rfactx_r 
+               !WRITE(narea+5000,*)zsurf(ji+2,jj  ,jk),zsurf(ji+2,jj+1,jk),zsurf(ji+2,jj+2,jk)
+               !WRITE(narea+5000,*)zsurfmsk(ji+2,jj  ,jk),zsurfmsk(ji+2,jj+1,jk),zsurfmsk(ji+2,jj+2,jk)
+               !WRITE(narea+5000,*)p_surf_crs    (ii,ij,jk),p_surf_crs_msk(ii,ij,jk)
+               !ENDIF
+               !iji=116 ; ijj=211
+               !iji=iji-nimpp_crs+1 ; ijj=ijj-njmpp_crs+1
+               !IF( ii==iji .AND. ij==ijj .AND. jk==74 )THEN
+               !WRITE(narea+5000,*)"SFC U =======> "
+               !WRITE(narea+5000,*)ii,ij,jk
+               !WRITE(narea+5000,*)ji,jj
+               !WRITE(narea+5000,*)zsurf(ji+2,jj  ,jk),zsurf(ji+2,jj+1,jk),zsurf(ji+2,jj+2,jk)
+               !WRITE(narea+5000,*)zsurfmsk(ji+2,jj  ,jk),zsurfmsk(ji+2,jj+1,jk),zsurfmsk(ji+2,jj+2,jk)
+               !WRITE(narea+5000,*)p_surf_crs    (ii,ij,jk),p_surf_crs_msk(ii,ij,jk)
+               !ENDIF
+            ENDDO
+         ENDDO
+      ENDDO
+
+      CASE ('V')
+
+      IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
+         IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
+            je_2 = mje_crs(2)
+            DO jk = 1, jpk
+               DO ji = nistr, niend, nn_factx
+                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
+                  !    
+                  p_surf_crs    (ii,2,jk) =  zsurf(ji,je_2  ,jk) + zsurf(ji+1,je_2  ,jk) + zsurf(ji+2,je_2  ,jk)
+                  !
+                  p_surf_crs_msk(ii,2,jk) =  zsurfmsk(ji,je_2,jk) + zsurfmsk(ji+1,je_2,jk) + zsurfmsk(ji+2,je_2,jk)
+                  !
+               ENDDO
+            ENDDO
+         ENDIF
+      ELSE
+         je_2 = mjs_crs(2)
+         DO jk = 1, jpk
+            DO ji = nistr, niend, nn_factx
+               ii   = ( ji - mis_crs(2) ) * rfactx_r + 2
+               !  
+               p_surf_crs    (ii,2,jk) = zsurf(ji,je_2+2,jk) + zsurf(ji+1,je_2+2,jk) + zsurf(ji+2,je_2+2,jk)
+               p_surf_crs_msk(ii,2,jk) = zsurfmsk(ji,je_2+2,jk) + zsurfmsk(ji+1,je_2+2,jk) + zsurfmsk(ji+2,je_2+2,jk)
+            ENDDO
+         ENDDO
+      ENDIF
+
+      DO jk = 1, jpk
+         DO jj = njstr, njend, nn_facty
+            DO ji = nistr, niend, nn_factx
+               ii = ( ji - mis_crs(2) ) * rfactx_r + 2
+               ij = ( jj - njstr ) * rfacty_r + 3
+               !
+               p_surf_crs    (ii,ij,jk) =  zsurf(ji,jj+2,jk) + zsurf(ji+1,jj+2,jk) + zsurf(ji+2,jj+2,jk)
+               p_surf_crs_msk(ii,ij,jk) =  zsurfmsk(ji,jj+2,jk) + zsurfmsk(ji+1,jj+2,jk) + zsurfmsk(ji+2,jj+2,jk)
+               iji=117 ; ijj=210
+               iji=iji-nimpp_crs+1 ; ijj=ijj-njmpp_crs+1
+               IF( ii==iji .AND. ij==ijj .AND. jk==74 )THEN
+               WRITE(narea+5000,*)"SFC V =======> "
+               WRITE(narea+5000,*)ii,ij,jk
+               WRITE(narea+5000,*)ji,jj
+               WRITE(narea+5000,*)zsurfmsk(ji,jj+2,jk),zsurfmsk(ji+1,jj+2,jk),zsurfmsk(ji+2,jj+2,jk)
+               WRITE(narea+5000,*)p_surf_crs    (ii,ij,jk),p_surf_crs_msk(ii,ij,jk)
+               ENDIF
+            ENDDO
+         ENDDO
+      ENDDO
+
+     END SELECT
+      DO jk=1,jpk
+      DO ji=1,jpi_crs
+      DO jj=1,jpj_crs
+         IF( p_surf_crs_msk(ji,jj,jk) .NE. p_surf_crs_msk(ji,jj,jk) )WRITE(narea+200,*)"SFC 4 ",ji,jj,jk,p_surf_crs_msk(ji,jj,jk)  ; call flush(narea+200)
+      ENDDO
+      ENDDO
+      ENDDO
       CALL crs_lbc_lnk( p_surf_crs    , cd_type, 1.0, pval=1.0 )
       CALL crs_lbc_lnk( p_surf_crs_msk, cd_type, 1.0, pval=1.0 )
-      WRITE(narea+200,*)"crs_dom_sfc end ", p_surf_crs    (2,18,1)
 
       CALL wrk_dealloc( jpi, jpj, jpk, zsurf, zsurfmsk )
Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90	(revision 5105)
@@ -66,7 +66,12 @@
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zt_crs, zs_crs !
       REAL(wp)       :: z2dcrsu, z2dcrsv
+      REAL(wp)       :: zmin,zmax
+      INTEGER :: i,j,ijis,ijie,ijjs,ijje
+      REAL(wp)       :: zw,zwp1,zum1,zu,zvm1,zv,zsnm,zsm,z
+      INTEGER ::  iji,ijj
       !!
        !!----------------------------------------------------------------------
       ! 
+      !IF(narea==267)WRITE(narea+5000,*)"========================================> crsfldt ",kt
 
       IF( nn_timing == 1 )   CALL timing_start('crs_fld')
@@ -91,4 +96,5 @@
          wn_crs   (:,:,:  ) = 0._wp    ! w
          avt_crs  (:,:,:  ) = 0._wp    ! avt
+         hdivb_crs(:,:,:  ) = 0._wp    ! hdiv
          hdivn_crs(:,:,:  ) = 0._wp    ! hdiv
          rke_crs  (:,:,:  ) = 0._wp    ! rke
@@ -110,4 +116,7 @@
 
       !  Temperature
+      zt(:,:,:) = tsb(:,:,:,jp_tem)  ;      zt_crs(:,:,:) = 0._wp
+      CALL crs_dom_ope( zt, 'VOL', 'T', tmask, zt_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
+      tsb_crs(:,:,:,jp_tem) = zt_crs(:,:,:)
       zt(:,:,:) = tsn(:,:,:,jp_tem)  ;      zt_crs(:,:,:) = 0._wp
       CALL crs_dom_ope( zt, 'VOL', 'T', tmask, zt_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
@@ -119,4 +128,7 @@
       
       !  Salinity
+      zs(:,:,:) = tsb(:,:,:,jp_sal)  ;      zs_crs(:,:,:) = 0._wp
+      CALL crs_dom_ope( zs, 'VOL', 'T', tmask, zs_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
+      tsb_crs(:,:,:,jp_sal) = zt_crs(:,:,:)
       zs(:,:,:) = tsn(:,:,:,jp_sal)  ;      zs_crs(:,:,:) = 0._wp
       CALL crs_dom_ope( zs, 'VOL', 'T', tmask, zs_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
@@ -127,5 +139,9 @@
 
       !  U-velocity
+      CALL crs_dom_ope( ub, 'SUM', 'U', umask, ub_crs, p_e12=e2u, p_e3=zfse3u, p_surf_crs=e2e3u_msk, psgn=-1.0 )
       CALL crs_dom_ope( un, 'SUM', 'U', umask, un_crs, p_e12=e2u, p_e3=zfse3u, p_surf_crs=e2e3u_msk, psgn=-1.0 )
+      !cbr
+      ub_crs(:,:,:) = ub_crs(:,:,:)*umask_crs(:,:,:)
+      un_crs(:,:,:) = un_crs(:,:,:)*umask_crs(:,:,:)
       !
       zt(:,:,:) = 0._wp     ;    zs(:,:,:) = 0._wp  ;   zt_crs(:,:,:) = 0._wp   ;    zs_crs(:,:,:) = 0._wp
@@ -146,5 +162,12 @@
 
       !  V-velocity
+      !IF(narea==267)WRITE(narea+5000,*)"deg vb_crs"
+      CALL crs_dom_ope( vb, 'SUM', 'V', vmask, vb_crs, p_e12=e1v, p_e3=zfse3v, p_surf_crs=e1e3v_msk, psgn=-1.0 )
+      !IF(narea==267)WRITE(narea+5000,*)"deg vn_crs"
       CALL crs_dom_ope( vn, 'SUM', 'V', vmask, vn_crs, p_e12=e1v, p_e3=zfse3v, p_surf_crs=e1e3v_msk, psgn=-1.0 )
+      !IF(narea==267)WRITE(narea+5000,*)"1 vn_crs(17,5,74) = ",vn_crs(17,5,74),vmask_crs(17,5,74),vn(46,13,74),vn(47,13,74),vn(48,13,74)
+      vb_crs(:,:,:) = vb_crs(:,:,:)*vmask_crs(:,:,:)
+      vn_crs(:,:,:) = vn_crs(:,:,:)*vmask_crs(:,:,:)
+      !IF(narea==267)WRITE(narea+5000,*)"2 vn_crs(17,5,74) = ",vn_crs(17,5,74),vmask_crs(17,5,74),vn(46,13,74),vn(47,13,74),vn(48,13,74)
       !                                                                                 
       zt(:,:,:) = 0._wp     ;    zs(:,:,:) = 0._wp  ;   zt_crs(:,:,:) = 0._wp   ;    zs_crs(:,:,:) = 0._wp
@@ -174,4 +197,10 @@
             DO jj = 2, jpj_crsm1
                IF( tmask_crs(ji,jj,jk ) > 0 ) THEN
+                  !z2dcrsu =  ( un_crs(ji  ,jj  ,jk) * crs_surfu_wgt(ji  ,jj  ,jk) ) &
+                  !   &     - ( un_crs(ji-1,jj  ,jk) * crs_surfu_wgt(ji-1,jj  ,jk) )
+                  !z2dcrsv =  ( vn_crs(ji  ,jj  ,jk) * crs_surfv_wgt(ji  ,jj  ,jk) ) &
+                  !   &     - ( vn_crs(ji  ,jj-1,jk) * crs_surfv_wgt(ji  ,jj-1,jk) )
+                  !
+                  !IF( crs_volt_wgt(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv ) / crs_volt_wgt(ji,jj,jk)
                   z2dcrsu =  ( un_crs(ji  ,jj  ,jk) * e2e3u_msk(ji  ,jj  ,jk) ) &
                      &     - ( un_crs(ji-1,jj  ,jk) * e2e3u_msk(ji-1,jj  ,jk) )
@@ -179,5 +208,38 @@
                      &     - ( vn_crs(ji  ,jj-1,jk) * e1e3v_msk(ji  ,jj-1,jk) )
                   !
-                  IF( ocean_volume_crs_t(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv ) / ocean_volume_crs_t(ji,jj,jk)
+                  !cbr
+                  !
+                  !bug1: il manquait le facvol_t(ji,jj,jk) ds la division ; ca creait des grosses erreurs de Wcrs ( vu en recalculant la divergence 3D )
+                  !bug2: mm test que bug1: on n'obtient tjs pas zero
+                  !on a la div calculée via ocean_volume_crs_t puis w via  e3t_crs ; or ,e1t_crs(ji,jj)*e2t_crs(ji,jj)*e3t_crs(ji,jj,jk) NE ocean_volume_crs_t*crs_volt_wgt(ji,jj,jk)
+                  !exp (117,211,74) : e1*e2*e3=235206030060.005 / ocean_volume_crs_t * facvol = 235205585307.810
+                  !                   e1*e2*e3-cean_volume_crs_t * facvol/(cean_volume_crs_t * facvol) ~1.e-6)  
+                  !IF( ocean_volume_crs_t(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv ) / (facvol_t(ji,jj,jk)*ocean_volume_crs_t(ji,jj,jk))
+                  !IF( ocean_volume_crs_t(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv ) / (e1t_crs(ji,jj)*e2t_crs(ji,jj)*e3t_crs(ji,jj,jk))
+                  IF( ocean_volume_crs_t(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv )
+
+               !iji=117 ; ijj=211
+               !iji=iji-nimpp_crs+1 ; ijj=ijj-njmpp_crs+1
+               !IF( ji==iji .AND. jj==ijj )THEN
+               !WRITE(narea+5000,*)"hdivn_crs =======> "
+               !WRITE(narea+5000,*) "u"  ,jk,un_crs(ji  ,jj  ,jk) ,e2e3u_msk(ji  ,jj  ,jk),un_crs(ji  ,jj  ,jk)*e2e3u_msk(ji  ,jj  ,jk)
+               !WRITE(narea+5000,*) "um1",jk,un_crs(ji-1,jj  ,jk) , e2e3u_msk(ji-1,jj  ,jk),un_crs(ji-1,jj  ,jk) * e2e3u_msk(ji-1,jj  ,jk)
+               !WRITE(narea+5000,*) "v",jk,vn_crs(ji  ,jj  ,jk) , e1e3v_msk(ji  ,jj  ,jk),vn_crs(ji  ,jj  ,jk) * e1e3v_msk(ji  ,jj  ,jk)
+               !WRITE(narea+5000,*) "vm1",jk,vn_crs(ji  ,jj-1,jk) , e1e3v_msk(ji  ,jj-1,jk),vn_crs(ji  ,jj-1,jk) * e1e3v_msk(ji  ,jj-1,jk)
+               !WRITE(narea+5000,*) "t1 ",jk,z2dcrsu,z2dcrsv, z2dcrsu + z2dcrsv,hdivn_crs(ji,jj,jk)
+               !WRITE(narea+5000,*) "t2 ",jk,e1t_crs(ji,jj),e2t_crs(ji,jj),e3t_crs(ji,jj,jk),e1t_crs(ji,jj)*e2t_crs(ji,jj)*e3t_crs(ji,jj,jk)
+               !WRITE(narea+5000,*) "t3 ",jk,ocean_volume_crs_t(ji,jj,jk),facvol_t(ji,jj,jk),facvol_t(ji,jj,jk)*ocean_volume_crs_t(ji,jj,jk)
+               !WRITE(narea+5000,*) "t4 ",jk, ( z2dcrsu + z2dcrsv ) / (facvol_t(ji,jj,jk)*ocean_volume_crs_t(ji,jj,jk))
+               !WRITE(narea+5000,*) "t5 ",jk, ( z2dcrsu + z2dcrsv ) / (e1t_crs(ji,jj)*e2t_crs(ji,jj)*e3t_crs(ji,jj,jk))
+               !ENDIF
+
+
+                  !IF( crs_volt_wgt(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv ) / crs_volt_wgt(ji,jj,jk)
+                  z2dcrsu =  ( ub_crs(ji  ,jj  ,jk) * e2e3u_msk(ji  ,jj  ,jk) ) &
+                     &     - ( ub_crs(ji-1,jj  ,jk) * e2e3u_msk(ji-1,jj  ,jk) )
+                  z2dcrsv =  ( vb_crs(ji  ,jj  ,jk) * e1e3v_msk(ji  ,jj  ,jk) ) &
+                     &     - ( vb_crs(ji  ,jj-1,jk) * e1e3v_msk(ji  ,jj-1,jk) )
+                  !
+                  IF( ocean_volume_crs_t(ji,jj,jk) .NE. 0._wp ) hdivb_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv ) / (facvol_t(ji,jj,jk)*ocean_volume_crs_t(ji,jj,jk) )
                ENDIF
             ENDDO
@@ -189,14 +251,25 @@
 
 
+      ! DO jk = 1, jpkm1          ! Interior value
+      !      DO jj = 1, jpj_crs
+      !         DO ji = 1, jpi_crs
+      !            IF( e3t_crs(ji,jj,jk) .NE. e3t_crs(ji,jj,jk) )WRITE(narea+200,*)"e3t_crs",e3t_crs(ji,jj,jk) ; call flush(narea+200)
+      !            IF( hdivn_crs(ji,jj,jk) .NE. hdivn_crs(ji,jj,jk) )WRITE(narea+200,*)"hdivn_crs",hdivn_crs(ji,jj,jk) ; call flush(narea+200)
+      !         END DO
+      !      END DO
+      !   END DO
+
       !  W-velocity
       IF( ln_crs_wn ) THEN
          CALL crs_dom_ope( wn, 'SUM', 'W', tmask, wn_crs, p_e12=e1e2t, p_surf_crs=e1e2w_msk, psgn=1.0 )
-       !  CALL crs_dom_ope( wn, 'VOL', 'W', tmask, wn_crs, p_e12=e1e2t, p_e3=zfse3w )
       ELSE
         wn_crs(:,:,jpk) = 0._wp
         DO jk = jpkm1, 1, -1
-           wn_crs(:,:,jk) = wn_crs(:,:,jk+1) - e3t_crs(:,:,jk) * hdivn_crs(:,:,jk)
+           !cbr wn_crs(:,:,jk) = wn_crs(:,:,jk+1) - e3t_crs(:,:,jk) * hdivn_crs(:,:,jk)
+           wn_crs(:,:,jk) = e1e2w_msk(:,:,jk+1)*wn_crs(:,:,jk+1) - hdivn_crs(:,:,jk)
+           WHERE( e1e2w_msk(:,:,jk) .NE. 0._wp )  wn_crs(:,:,jk) =  wn_crs(:,:,jk) /e1e2w_msk(:,:,jk) 
         ENDDO
       ENDIF
+
       CALL iom_put( "woce", wn_crs  )   ! vertical velocity
       !  free memory
@@ -216,5 +289,7 @@
       !  sbc fields  
 
+      CALL crs_dom_ope( sshb , 'VOL', 'T', tmask, sshb_crs , p_e12=e1e2t, p_e3=zfse3t         , psgn=1.0 )  
       CALL crs_dom_ope( sshn , 'VOL', 'T', tmask, sshn_crs , p_e12=e1e2t, p_e3=zfse3t         , psgn=1.0 )  
+      CALL crs_dom_ope( ssha , 'VOL', 'T', tmask, ssha_crs , p_e12=e1e2t, p_e3=zfse3t         , psgn=1.0 )  
       CALL crs_dom_ope( utau , 'SUM', 'U', umask, utau_crs , p_e12=e2u  , p_surf_crs=e2u_crs  , psgn=1.0 )
       CALL crs_dom_ope( vtau , 'SUM', 'V', vmask, vtau_crs , p_e12=e1v  , p_surf_crs=e1v_crs  , psgn=1.0 )
@@ -224,4 +299,5 @@
       CALL crs_dom_ope( emp_b, 'SUM', 'T', tmask, emp_b_crs, p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
       CALL crs_dom_ope( emp  , 'SUM', 'T', tmask, emp_crs  , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
+      CALL crs_dom_ope( fmmflx,'SUM', 'T', tmask, fmmflx_crs, p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
       CALL crs_dom_ope( sfx  , 'SUM', 'T', tmask, sfx_crs  , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
       CALL crs_dom_ope( fr_i , 'SUM', 'T', tmask, fr_i_crs , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
@@ -237,4 +313,115 @@
       CALL iom_put( "ice_cover", fr_i_crs )   ! ice cover output 
 
+      !cbr
+      !IF(narea==267)WRITE(narea+5000,*)"vn_crs(17,5,74) = ",vn_crs(17,5,74)
+      !ji=117 ; jj=211 ; jk=74
+      !ji=ji-nimpp_crs+1 ; jj=jj-njmpp_crs+1
+      !IF( ji .GE. 2 .AND. ji .LE. jpi_crs-1 .AND. jj .GE. 2 .AND. jj .LE. jpj_crs-1 )THEN
+      !WRITE(narea+5000,*)"=======> kt ",kt
+      !WRITE(narea+5000,*)ji,jj,glamt(ji,jj),gphit(ji,jj)
+      !WRITE(narea+5000,*)"um1  crs ",umask_crs(ji-1,jj,jk),e2e3u_msk(ji-1,jj,jk),un_crs(ji-1,jj,jk),umask_crs(ji-1,jj,jk)*e2e3u_msk(ji-1,jj,jk)*un_crs(ji-1,jj,jk)
+      !WRITE(narea+5000,*)"u    crs ",umask_crs(ji,jj,jk),e2e3u_msk(ji,jj,jk),un_crs(ji,jj,jk),umask_crs(ji,jj,jk)*e2e3u_msk(ji,jj,jk)*un_crs(ji,jj,jk)
+      !WRITE(narea+5000,*)"vm1  crs ",vmask_crs(ji,jj-1,jk),e1e3v_msk(ji,jj-1,jk),vn_crs(ji,jj-1,jk),vmask_crs(ji,jj-1,jk)*e1e3v_msk(ji,jj-1,jk)*vn_crs(ji,jj-1,jk)
+      !WRITE(narea+5000,*)"v    crs ",vmask_crs(ji,jj,jk),e1e3v_msk(ji,jj,jk),vn_crs(ji,jj,jk),vmask_crs(ji,jj,jk)*e1e3v_msk(ji,jj,jk)*vn_crs(ji,jj,jk)
+      !WRITE(narea+5000,*)"wp1  crs ",tmask_crs(ji,jj,jk+1),e1e2w_msk(ji,jj,jk+1),wn_crs(ji,jj,jk+1),tmask_crs(ji,jj,jk+1)*e1e2w_msk(ji,jj,jk+1)*wn_crs(ji,jj,jk+1)
+      !WRITE(narea+5000,*)"w    crs ",tmask_crs(ji,jj,jk),e1e2w_msk(ji,jj,jk),wn_crs(ji,jj,jk),tmask_crs(ji,jj,jk)*e1e2w_msk(ji,jj,jk)*wn_crs(ji,jj,jk)
+      !z = umask_crs(ji,jj,jk)*e2e3u_msk(ji,jj,jk)*un_crs(ji,jj,jk) - umask_crs(ji-1,jj,jk)*e2e3u_msk(ji-1,jj,jk)*un_crs(ji-1,jj,jk) + &
+      !    vmask_crs(ji,jj,jk)*e1e3v_msk(ji,jj,jk)*vn_crs(ji,jj,jk) - vmask_crs(ji,jj-1,jk)*e1e3v_msk(ji,jj-1,jk)*vn_crs(ji,jj-1,jk) + &
+      !    tmask_crs(ji,jj,jk)*e1e2w_msk(ji,jj,jk)*wn_crs(ji,jj,jk) - tmask_crs(ji,jj,jk+1)*e1e2w_msk(ji,jj,jk+1)*wn_crs(ji,jj,jk+1)
+      !WRITE(narea+5000,*)"sum ",z
+      !ijie = mie_crs(ji)
+      !ijis = mis_crs(ji)
+      !ijje = mje_crs(jj)
+      !ijjs = mjs_crs(jj)
+      !DO i=ijis,ijie
+      !   DO j=ijjs,ijje
+      !       WRITE(narea+5000,*)"tmask",i,j,tmask(i,j,jk)
+      !   ENDDO           
+      !ENDDO           
+
+      !z=0._wp
+      !zsm=0._wp
+      !DO i=ijis,ijie
+      !   DO j=ijjs,ijje
+      !       WRITE(narea+5000,*)"w",i,j,tmask(i,j,jk),e1t(i,j),e2t(i,j),e1t(i,j)*e2t(i,j),wn(i,j,jk)
+      !       z=z+tmask(i,j,jk)*e1t(i,j)*e2t(i,j)*wn(i,j,jk)
+      !       zsm=zsm+tmask(i,j,jk)*e1t(i,j)*e2t(i,j)
+      !   ENDDO           
+      !ENDDO   
+        
+      !zw=z
+      !WRITE(narea+5000,*)"w sum ",zsm,zw           
+      !z=0._wp
+      !zsm=0._wp
+      !DO i=ijis,ijie
+      !   DO j=ijjs,ijje
+      !       WRITE(narea+5000,*)"wp1 ",i,j,tmask(i,j,jk+1),e1t(i,j),e2t(i,j),e1t(i,j)*e2t(i,j),wn(i,j,jk+1)
+      !       z=z+tmask(i,j,jk+1)*e1t(i,j)*e2t(i,j)*wn(i,j,jk+1)
+      !       zsm=zsm+tmask(i,j,jk+1)*e1t(i,j)*e2t(i,j)
+      !   ENDDO
+      !ENDDO
+      !zwp1=z
+      !WRITE(narea+5000,*)"wp1 sum ",zsm,zwp1  
+      !z=0._wp
+      !zsm=0._wp
+      !i=ijis-1
+      !DO j=ijjs,ijje
+      !    WRITE(narea+5000,*)"um1",i,j,umask(i,j,jk),e2u(i,j),e3u_0(i,j,jk),e2u(i,j)*e3u_0(i,j,jk),un(i,j,jk)
+      !    z=z+e2u(i,j)*e3u_0(i,j,jk)*un(i,j,jk)
+      !    zsm=zsm+e2u(i,j)*e3u_0(i,j,jk)*umask(i,j,jk)
+      !ENDDO
+      !zum1=z
+      !WRITE(narea+5000,*)"um1 sum ",zsm,zum1          
+      !z=0._wp
+      !zsm=0._wp
+      !i=ijie
+      !DO j=ijjs,ijje
+      !    WRITE(narea+5000,*)"u",i,j,umask(i,j,jk),e2u(i,j),e3u_0(i,j,jk),e2u(i,j)*e3u_0(i,j,jk),un(i,j,jk)
+      !    z=z+e2u(i,j)*e3u_0(i,j,jk)*un(i,j,jk)
+      !    zsm=zsm+e2u(i,j)*e3u_0(i,j,jk)*umask(i,j,jk)
+      !ENDDO           
+      !zu=z
+      !WRITE(narea+5000,*)"u   sum ",zsm,zu          
+      !z=0._wp
+      !zsm=0._wp
+      !j=ijjs-1
+      !DO i=ijis,ijie
+      !    WRITE(narea+5000,*)"vm1",i,j,vmask(i,j,jk),e1v(i,j),e3v_0(i,j,jk),e1v(i,j)*e3v_0(i,j,jk),vn(i,j,jk)
+      !    z=z+e1v(i,j)*e3v_0(i,j,jk)*vn(i,j,jk)
+      !    zsm=zsm+e1v(i,j)*e3v_0(i,j,jk)*vmask(i,j,jk)
+      !ENDDO           
+      !zvm1=z
+      !WRITE(narea+5000,*)"vm1 sum ",zsm,zvm1           
+      !z=0._wp
+      !zsm=0._wp
+      !j=ijje
+      !DO i=ijis,ijie
+      !    WRITE(narea+5000,*)"v",i,j,vmask(i,j,jk),e1v(i,j),e3v_0(i,j,jk),e1v(i,j)*e3v_0(i,j,jk),vn(i,j,jk)
+      !    z=z+e1v(i,j)*e3v_0(i,j,jk)*vn(i,j,jk)
+      !    zsm=zsm+e1v(i,j)*e3v_0(i,j,jk)*vmask(i,j,jk)
+      !ENDDO           
+      !zv=z
+      !WRITE(narea+5000,*)"v   sum ",zv           
+      !WRITE(narea+5000,*)"sum ",zw+zwp1+zum1+zu+zvm1+zv
+      !DO i=ijis,ijie
+      !   DO j=ijjs,ijje
+      !       WRITE(narea+5000,*)"msk",i,j,tmask(i,j,jk),umask(i,j,jk),vmask(i,j,jk)
+      !       WRITE(narea+5000,*)"vel",i,j,un(i,j,jk),vn(i,j,jk),wn(i,j,jk)
+      !   ENDDO
+      !ENDDO
+
+      !DO i=ijis,ijie
+      !   DO j=ijjs,ijje
+      !      z = un(i,j,jk)*e2u(i,j)*e3u_0(i,j,jk)*umask(i,j,jk) - un(i-1,j,jk)*e2u(i-1,j)*e3u_0(i-1,j,jk)*umask(i-1,j,jk) + &
+      !          vn(i,j,jk)*e1v(i,j)*e3v_0(i,j,jk)*vmask(i,j,jk) - vn(i,j-1,jk)*e1v(i,j-1)*e3v_0(i,j-1,jk)*vmask(i,j-1,jk) + &
+      !          wn(i,j,jk)*e2t(i,j)*e1t(i,j)*tmask(i,j,jk)     - wn(i,j,jk+1)*e2t(i,j)*e1t(i,j)*tmask(i,j,jk+1)
+      !       WRITE(narea+5000,*)"div ",i,j,jk,z
+      !   ENDDO
+      !ENDDO
+
+      !ENDIF
+      
+  
+
       !  free memory
       CALL wrk_dealloc( jpi, jpj, jpk, zfse3t, zfse3w )
Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90	(revision 5105)
@@ -68,7 +68,8 @@
       INTEGER  :: ierr                                ! allocation error status
       INTEGER  ::   ios                 ! Local integer output status for namelist read
+      REAL(wp) :: zmin,zmax
       REAL(wp), DIMENSION(:,:,:), POINTER :: zfse3t, zfse3u, zfse3v, zfse3w
 
-      NAMELIST/namcrs/ nn_factx, nn_facty, nn_binref, nn_msh_crs, nn_crs_kz, ln_crs_wn
+      NAMELIST/namcrs/ nn_factx, nn_facty, nn_binref, nn_msh_crs, nn_crs_kz, ln_crs_wn, ln_crs_top
       !!----------------------------------------------------------------------
       !
@@ -160,4 +161,13 @@
      CALL crs_dom_hgr( e1f, e2f, 'F', e1f_crs, e2f_crs )
 
+     WHERE(e1t_crs == 0._wp) e1t_crs=r_inf
+     WHERE(e1u_crs == 0._wp) e1u_crs=r_inf
+     WHERE(e1v_crs == 0._wp) e1v_crs=r_inf
+     WHERE(e1f_crs == 0._wp) e1f_crs=r_inf
+     WHERE(e2t_crs == 0._wp) e2t_crs=r_inf
+     WHERE(e2u_crs == 0._wp) e2u_crs=r_inf
+     WHERE(e2v_crs == 0._wp) e2v_crs=r_inf
+     WHERE(e2f_crs == 0._wp) e2f_crs=r_inf
+
      e1e2t_crs(:,:) = e1t_crs(:,:) * e2t_crs(:,:)
      
@@ -169,4 +179,5 @@
       CASE ( 0, 1, 4 )           ! mesh on the sphere
 
+         zmin=MINVAL(ABS(gphif_crs(:,:)));zmax=MAXVAL(ABS(gphif_crs(:,:)));CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"gphif_crs",zmin,zmax
          ff_crs(:,:) = 2. * omega * SIN( rad * gphif_crs(:,:) )
 
@@ -190,4 +201,8 @@
 
      !    3.d.2   Surfaces 
+     e2e3u_crs(:,:,:)=0._wp
+     e2e3u_msk(:,:,:)=0._wp
+     e1e3v_crs(:,:,:)=0._wp
+     e1e3v_msk(:,:,:)=0._wp
      CALL crs_dom_sfc( tmask, 'W', e1e2w_crs, e1e2w_msk, p_e1=e1t, p_e2=e2t    )
      WRITE(narea+200,*)"e1e2w_crs(2,18,1) ",e1e2w_crs(2,18,1)
@@ -207,5 +222,12 @@
 
               facsurfu(ji,jj,jk) = umask_crs(ji,jj,jk) * e2e3u_msk(ji,jj,jk)  
-              IF( e2e3u_crs(ji,jj,jk) .NE. 0._wp ) facsurfu(ji,jj,jk) = facsurfu(ji,jj,jk) / e2e3u_crs(ji,jj,jk)
+
+              IF( facsurfu(ji,jj,jk) .NE. facsurfu(ji,jj,jk) )WRITE(narea+200,*)'BUG1',facsurfu(ji,jj,jk);call flush(narea+200)
+              IF( e2e3u_crs(ji,jj,jk) .NE. e2e3u_crs(ji,jj,jk) ) WRITE(narea+200,*)'BUG2',e2e3u_crs(ji,jj,jk);call flush(narea+200)
+              IF( e2e3u_msk(ji,jj,jk) .NE. e2e3u_msk(ji,jj,jk) ) WRITE(narea+200,*)'BUG3',e2e3u_msk(ji,jj,jk) ;call flush(narea+200)
+              IF( e1e2w_msk(ji,jj,jk) .NE. e1e2w_msk(ji,jj,jk) ) WRITE(narea+200,*)'BUG4',ji,jj,jk,e1e2w_msk(ji,jj,jk) ;call flush(narea+200)
+              IF( tmask(ji,jj,jk) .NE. tmask(ji,jj,jk) ) WRITE(narea+200,*)'BUG4',tmask(ji,jj,jk) ;call flush(narea+200)
+              IF( e1t(ji,jj) .NE. e1t(ji,jj) ) WRITE(narea+200,*)'BUG5',e1t(ji,jj) ;call flush(narea+200)
+              IF( e1t(ji,jj) .NE. e2t(ji,jj) ) WRITE(narea+200,*)'BUG6',e2t(ji,jj) ;call flush(narea+200)
 
               facsurfv(ji,jj,jk) = vmask_crs(ji,jj,jk) * e1e3v_msk(ji,jj,jk)  
@@ -224,4 +246,8 @@
      CALL crs_dom_e3( e1v, e2v, zfse3v, e1e3v_crs, 'V', vmask, e3v_crs, e3v_max_crs)
      CALL crs_dom_e3( e1t, e2t, zfse3w, e1e2w_crs, 'W', tmask, e3w_crs, e3w_max_crs)
+     WHERE(e3t_max_crs == 0._wp) e3t_max_crs=r_inf
+     WHERE(e3u_max_crs == 0._wp) e3u_max_crs=r_inf
+     WHERE(e3v_max_crs == 0._wp) e3v_max_crs=r_inf
+     WHERE(e3w_max_crs == 0._wp) e3w_max_crs=r_inf
 
      ! Reset 0 to e3t_0 or e3w_0
@@ -264,5 +290,9 @@
         CALL dom_grid_glo   ! Return to parent grid domain
      ENDIF
-     
+    
+
+      rhop_crs(:,:,:)=0._wp ; rhd_crs(:,:,:)=0._wp ; rb2_crs(:,:,:)=0._wp
+
+ 
      !---------------------------------------------------------
      ! 7. Finish and clean-up
Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 5105)
@@ -149,6 +149,8 @@
    !                                                  ! (mi0=1 and mi1=0 if the global index is not in the local domain)
    INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nimppt, njmppt   !: i-, j-indexes for each processor
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nimpptea, njmpptno !: i-, j-indexes for each processor's northern and eastern neighbour
    INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   ibonit, ibonjt   !: i-, j- processor neighbour existence
    INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nlcit , nlcjt    !: dimensions of every subdomain
+   INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nlcitea          !: dimensions of every subdomain eastern neighbour
    INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nldit , nldjt    !: first, last indoor index for each i-domain
    INTEGER, PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   nleit , nlejt    !: first, last indoor index for each j-domain
@@ -337,5 +339,6 @@
       !
       ALLOCATE( rdttra(jpk), r2dtra(jpk), mig(jpi), mjg(jpj), nfiimpp(jpni,jpnj),  &
-         &      nfipproc(jpni,jpnj), nfilcit(jpni,jpnj), STAT=ierr(1) )
+         &      nfipproc(jpni,jpnj), nfilcit(jpni,jpnj), &
+         &      njmpptno(jpnij), nimpptea(jpnij), nlcitea(jpnij), STAT=ierr(1) )
          !
       ALLOCATE( nimppt(jpnij) , ibonit(jpnij) , nlcit(jpnij) , nlcjt(jpnij) ,     &
Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 5105)
@@ -18,5 +18,10 @@
    !!   iom_rstput     : write a field in a restart file (interfaced to several routines)
    !!--------------------------------------------------------------------
-   USE dom_oce         ! ocean space and time domain
+   USE dom_oce, ONLY : nimpp, njmpp, nlci, nlcj, nldi, nldj, nlei, nlej, & 
+                       mig, mjg, narea, &
+                       gphiv, gphif, &
+                       agrif_root, agrif_cfixed, lk_agrif, &
+                       rdt,rdttra, gdept_0, ln_crs, gdepw_0,  adatrj, fjulday
+
    USE c1d             ! 1D vertical configuration
    USE flo_oce         ! floats module declarations
